/**
 * File:   macros.h
 * Author: Benjamin Pickhardt (hackCraft.de)
 *
 * Created on March 11, 2008, 3:04 PM
 */

#ifndef _MACROS_H
#define	_MACROS_H

#include "ctrl.h"
#include "math3d.h"
#include "snippetsgl.h"
#include "instfont.h"

// Misc.

#define NATO_Alphabet(letter) \
({ \
    char* name[] = { \
        "Alpha", "Bravo", "Charlie", "Delta", "Echo", "Foxtrot", \
        "Golf", "Hotel", "India", "Juliett", "Kilo", "Lima", "Mike", \
        "November", "Oscar", "Papa", "Quibec", "Romeo", "Sierra", \
        "Tango", "Uniform", "Victor", "Whiskey", "X-Ray", "Yankee", "Zulu" \
    }; \
    name[letter]; \
})


#define getSystemHour(hour1f) \
{ \
  time_t t = time(NULL); \
  tm *l = localtime(&t); \
  hour1f = (float) (l->tm_hour + l->tm_min / 60.0 + l->tm_sec / 3600.0); \
}


#define generateTexture3D(WIDTH, HEIGHT, DEPTH, texture_ptr,  d_func_xyz, r_func_dxyz, g_func_dxyz, b_func_dxyz, sx, sy, sz) \
{ \
    unsigned char* t = texture_ptr; \
    loopi(WIDTH) { loopj(HEIGHT) { loopk(DEPTH) { \
        unsigned char delta = d_func_xyz(sx*i, sy*j, sz*k); \
        (*t++) = r_func_dxyz(delta, sx*i, sy*j, sz*k); \
        (*t++) = g_func_dxyz(delta, sx*i, sy*j, sz*k); \
        (*t++) = b_func_dxyz(delta, sx*i, sy*j, sz*k); \
    }}}; \
}

#define deltaFunc_NoisyPlasma(i,j,k)   ( 160 + (rand()%30) + 60*(0.5 + 0.5 * sin((9*i+3*j+20)*0.017454) * sin((9*j+3*k+60)*0.017454) * sin((9*k+3*i+80)*0.017454) ) )
#define ColorFunc_Delta(delta, x,y,z)  (delta)


#endif	/* _MACROS_H */

