
#include <list>

#include "cMission.h"

#include "cObject.h"
#include "main.h"

#include <vector>
#include <cassert>

void cMission::checkConditions() {
    // Destroyed all necessary enemies?
    int n = 0;
    loopiv(mVictory) if (mVictory[i]->hasRole(cObject::DEAD)) n++;
    if (n != 0 && n == mVictory.size()) {
        onVictory();
        return;
    }
    // Destroyed any neccessary friend?
    n = 0;
    loopiv(mDefeat) if (mDefeat[i]->hasRole(cObject::DEAD)) n++;
    if (n != 0) {
        onDefeat();
        return;
    }
}

void cMission::onVictory() {
    if (mState != -1) {
        mState = -1;
        cWorld::instance->sendMessage(
                "   (+) Primary target fullfilled.\n   (+) You Won!\n   (+) Hit ESC to finish Mission\n"
                );
    }
}

void cMission::onDefeat() {
    if (mState != -2) {
        mState = -2;
        cWorld::instance->sendMessage(
                "   (-) You Lost!\n   (+) Hit ESC to finish Mission\n"
                );
    }
}

cObject* cEmptyMission::init(cWorld* world) {
    world->mBackground = new cDomeBackground;

    if (true) {
        world->mHour = 12;
        world->mMinute = 0;
        world->mSecond = 0;
    } else {
        float hour;
        getSystemHour(hour);
        world->mHour = (int) hour;
        world->mMinute = 0;
        world->mSecond = 0;
    }

    cObject* player = NULL;

    if (true) {
        float pos[3] = {-50, 0, -50};
        cMech* mech = new cMech(pos);
        assert(mech != NULL);

        mech->mPad = new cPad;
        mech->mName = "Alpha";

        mech->mController->mEnabled = false; // Disable Autopilot.
        mech->mRoles |= (1UL << cObject::RED) | (1UL << cObject::HUMANPLAYER);
        mech->mEnemies |= (1UL << cObject::BLUE);

        player = mech;

        //cController* ai = new cController;
        //ai->newState(cController::TARGET, "Delta");
        //mech->mController = ai;

        world->spawnObject(mech);

        if (true) {

            //mech->mountWeapon((char*)"LTorsor", new cExplosion);
            mech->mountWeapon((char*) "LTorsor", new cPlasmaGun);
            if (true) {
                mech->mountWeapon((char*) "LLoArm", new cMachineGun);
                //mech->mountWeapon((char*)"LTorsor",  new cMachineGun);
                //mech->mountWeapon((char*)"RTorsor",  new cMachineGun);
                mech->mountWeapon((char*) "RLoArm", new cMachineGun);
            }
            mech->mountWeapon((char*) "RTorsor", new cPlasmaGun);
            //mech->mountWeapon((char*)"RLoArm",  new cHomingMissile);
            //mech->mountWeapon((char*)"RLoArm",  new cRaybeam);
        }
    }

    mVictory.push_back(player);
    return player;
}


// ------------------------------------------------------------

cObject* cTestMission::init(cWorld* world) {
    world->mBackground = new cDomeBackground;

    if (true) {
        world->mHour = 12;
        world->mMinute = 0;
        world->mSecond = 0;
    } else {
        float hour;
        getSystemHour(hour);
        world->mHour = (int) hour;
        world->mMinute = 0;
        world->mSecond = 0;
    }

    cObject* player = initMechs(world);
    initArchitecture(world);
    initFlora(world);
    mDefeat.push_back(player);
    return player;
}

void cTestMission::onVictory() {
    cMission::onVictory();
}

void cTestMission::onDefeat() {
    cMission::onDefeat();
}

cObject* cTestMission::initMechs(cWorld* planet) {
    srand(0);
    cObject* player = NULL;

    // Player
    if (true) {
        float pos[3] = {-20, 0, -50};
        float rot[3] = {0, -170, 0};
        cMech* mech = new cMech(pos, rot);
        assert(mech != NULL);
        player = mech;

        mech->mPad = new cPad;
        mech->mName = "Alpha";
        mech->mController->mEnabled = false; // Disable Autopilot.
        mech->addRole(cObject::RED);
        mech->addRole(cObject::HUMANPLAYER);
        mech->addEnemy(cObject::BLUE);

        planet->spawnObject(mech);

        if (true) {
            if (!true) mech->mountWeapon((char*) "LTorsor", new cExplosion);
            if (true) {
                mech->mountWeapon((char*) "LTorsor", new cMachineGun);
                mech->mountWeapon((char*) "RTorsor", new cMachineGun);
            }
            if (!true) {
                mech->mountWeapon((char*) "LTorsor", new cPlasmaGun);
                mech->mountWeapon((char*) "RTorsor", new cPlasmaGun);
            }
            if (!true) {
                mech->mountWeapon((char*) "LLoArm", new cMachineGun);
                mech->mountWeapon((char*) "RLoArm", new cMachineGun);
            }
            if (!true) {
                mech->mountWeapon((char*) "RLoArm", new cHomingMissile);
                mech->mountWeapon((char*) "RLoArm", new cRaybeam);
            }
        }
    }

    // Allied
    if (true) {
        float pos[3] = {+10 * 1, 0, -50 * 1};
        float rot[3] = {0, -210, 0};
        cMech* mech = new cMech(pos, rot);
        assert(mech != NULL);

        mech->mPad = new cPad();
        mech->mName = "Bravo";

        mech->addRole(cObject::RED);
        mech->addEnemy(cObject::BLUE);

        planet->spawnObject(mech);

        if (true) {
            //mech->mountWeapon((char*)"LLoArm",  new cMachineGun);
            //mech->mountWeapon((char*)"RLoArm",  new cMachineGun);
            mech->mountWeapon((char*) "RTorsor", new cHomingMissile);
            mech->mountWeapon((char*) "LTorsor", new cHomingMissile);
        }

        //ai->newState(cControllerI::TARGET, "Charly");
        //ai->newState(cController::ROUTE, "Attackroute");
        //mech->mController->newInstruction(cController::FOLLOW, player->mSerial);
        float d[] = {+100, 0, -50};
        mech->mController->pushGotoDestination(d);
        float c[] = {+100, 0, +120};
        mech->mController->pushGotoDestination(c);
        float b[] = {-20, 0, +120};
        mech->mController->pushGotoDestination(b, false);
        float a[] = {-15, 0, -50};
        mech->mController->pushGotoDestination(a);
        mech->mController->pushRepeatInstructions(4);
        mech->mController->pushWaitEvent(1000 * 2);
    }


#if 0
    for (int i = 0; i < 25; i++) {
        float s = 30;
        float pos[3] = {(i % 6) * s - 50, 0, 20 + (i / 6) * s + (i / 6 % 2) * s / 2};
        cMech* mech = new cMech(pos);
        assert(mech != NULL);

        mech->mPad = new cPad();
        mech->mName = "X";
        mech->addRole(cObject::BLUE);
        mech->addEnemy(cObject::RED);

        planet->spawnObject(mech);

        if (true) {
            mech->mountWeapon((char*) "LLoArm", new cMachineGun);
            mech->mountWeapon((char*) "RLoArm", new cMachineGun);
            mech->mountWeapon((char*) "RTorsor", new cMachineGun);
            mech->mountWeapon((char*) "LTorsor", new cMachineGun);
        }
    }

    for (int i = 0; i < 20; i++) {
        float pos[3] = {(i % 6) * 10 - 50, 0, -20 + (i / 6)*10 + (i / 6 % 2)*5};
        cMech* mech = new cMech(pos);
        assert(mech != NULL);

        mech->mPad = new cPad();
        mech->mName = "Y";
        mech->addRole(cObject::RED);
        mech->addEnemy(cObject::BLUE);

        planet->spawnObject(mech);

        if (true) {
            mech->mountWeapon((char*) "LLoArm", new cSparkGun);
            mech->mountWeapon((char*) "RLoArm", new cSparkGun);
            mech->mountWeapon((char*) "RTorsor", new cSparkGun);
            mech->mountWeapon((char*) "LTorsor", new cRaybeam);
        }
    }
#endif

    // Primary
    if (!true) {
        float pos[3] = {+50, 0, +50};
        cMech* mech = new cMech(pos);
        assert(mech != NULL);

        mech->mPad = new cPad();
        mech->mName = "Charly";

        mech->addRole(cObject::BLUE);
        mech->addEnemy(cObject::RED);

        //ai->newState(cController::WAIT, (char*) NULL);
        //ai->newState(cController::TARGET, "Delta");
        //ai->newState(cController::ROUTE, "Attackroute");

        mVictory.push_back(mech);

        planet->spawnObject(mech);

        if (true) {
            //mech->mountWeapon((char*)"LTorsor", new cExplosion);
            mech->mountWeapon((char*) "LLoArm", new cSparkGun);
            mech->mountWeapon((char*) "RLoArm", new cSparkGun);
            //mech->mountWeapon((char*)"RTorsor",  new cHomingMissile);
        }
    }

    // Secondary
    if (true) {
        float pos[3] = {-50, 0, +50};
        cMech* mech = new cMech(pos);
        assert(mech != NULL);

        mech->mPad = new cPad();
        mech->mName = "Delta";

        mech->addRole(cObject::BLUE);
        mech->addEnemy(cObject::RED);

        //ai->newState(cController::ENGAGE, "Charly");
        //ai->newState(cController::ROUTE, navs);

        //gCameraEntity = mech;
        planet->spawnObject(mech);

        if (true) {
            mech->mountWeapon((char*) "LLoArm", new cSparkGun);
            //mech->mountWeapon((char*)"LLoArm",  new cRaybeam);
            //mech->mountWeapon((char*)"RLoArm",  new cRaybeam);
            //mech->mountWeapon((char*)"RLoArm",  new cMachineGun);
            //mech->mountWeapon((char*)"RTorsor",  new cHomingMissile);
        }
    }

    return player;
}

void cTestMission::initArchitecture(cWorld* planet) {
    srand(0);

    const int b = 0;
    const int width = 11;
    const int height = 11;
    int buildings[][width] = {
        { b, b, b, b, b, b, b, b, b, b, b},
        { b, 4, 4, 0, 6, 6, 0, 3, 4, 3, b},
        { 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, b},
        { b, 3, 3, 0, 5, 12, 0, 4, 6, 6, b},
        { b, 4, 6, 0, 8, 10, 0, 4, 11, 11, b},
        { b, 6, 4, 0, 0, 0, 0, 0, 0, 0, b},
        { b, 3, 3, 0, 11, 9, 0, 7, 5, 3, b},
        { b, 0, 0, 0, 0, 0, 0, 0, 0, 0, b},
        { b, 6, 6, 0, 5, 5, 0, 9, 4, 3, b},
        { b, 6, 6, 0, 5, 5, 0, 7, 6, 3, b},
        { b, b, b, b, b, b, b, b, b, b, b},
    };

    int roads[][width] = {
        { 1, 1, 1, 1, 1, 1, 1, 0, 0, 0, 0},
        { 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0},
        { 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1},
        { 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 1},
        { 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 1},
        { 1, 0, 0, 1, 1, 1, 1, 1, 1, 1, 1},
        { 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 1},
        { 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1},
        { 0, 0, 0, 1, 0, 0, 1, 0, 0, 0, 1},
        { 0, 0, 0, 1, 0, 0, 1, 0, 0, 0, 1},
        { 0, 0, 0, 1, 1, 1, 1, 1, 1, 1, 1},
    };

    // Ground-Tiles
    for (int i = 0; i < width; i++) {
        for (int j = 0; j < height; j++) {
            int center = roads[i][j];
            int east = (i == 0) ? 0 : roads[(i + width - 1) % width][j];
            int west = ((i + 1) == width) ? 0 : roads[(i + 1) % width][j];
            int north = (j == 0) ? 0 : roads[i][(j + height - 1) % height];
            int south = ((j + 1) == height) ? 0 : roads[i][(j + 1) % height];

            if (center == 1) {
                if (east == 1 && west == 1 && north == 1 && south == 1) {
                    planet->spawnObject(new cTile(i, 0, j, cTile::KIND_ROAD_JUNKTION));
                } else if (west == 1 || east == 1) {
                    planet->spawnObject(new cTile(i, 0, j, cTile::KIND_ROAD_EASTWEST));
                } else if (south == 1 || north == 1) {
                    planet->spawnObject(new cTile(i, 0, j, cTile::KIND_ROAD_NORTHSOUTH));
                }

            } else {
                //planet->spawnObject(new cTile(i,0,j, cTile::KIND_CONCRETE));
            }
        }
    }

    // Stacked House-Tiles
    for (int i = 0; i < width; i++) {
        for (int j = 0; j < height; j++) {
            int h_ = buildings[i][j] / 100;
            int h = buildings[i][j] % 100;
            if (h > 0) {
                // Determine width of chunk.
                int a = i;
                while ((buildings[a][j] % 100) >= h && a < width) {
                    a++;
                }
                a--;

                // Determine height of chunk.
                int b = j + 1;
                while (b < height) {
                    int t;
                    for (t = i; (t <= a) && ((buildings[t][b] % 100) >= h); t++);
                    if (t <= a) break;
                    b++;
                }
                b--;
                /*
                int b = j;
                while ((buildings[a][b] % 100) >= h && b < height) { b++; }
                b--;
                 */
                //printf("building at: %i %i %i - %i %i %i\n", i, h_, j, a, h, b);
                for (int x = i; x <= a; x++) {
                    for (int y = j; y <= b; y++) {
                        //buildings[x][y] -= h;
                        //int old = buildings[x][y];
                        buildings[x][y] += h * 100 - h;
                        while (buildings[x][y] < 0) buildings[x][y] += 1;
                        //printf("%i => %i %i\n", old, buildings[x][y], old + h*100 -h);
                    }
                }
                planet->spawnObject(new cBuilding(i * 3, h_, j * 3, (a - i + 1)*3, h, (b - j + 1)*3));
            }
        }
    }

    if (!true) {
        planet->spawnObject(new cBuilding(-6, 0, 0, 5, 4, 8));
    }


    if (!true) {
        int x = 35;
        int z = 40;
        int n = 10;
        for (int i = 0; i < n; i++) {
            planet->spawnObject(new cBuilding(i + x, i, i + z, 22 - 2 * i, 1, 22 - 2 * i));
        }
    }

}

void cTestMission::initFlora(cWorld* planet) {
    srand(0);

    struct plantplan {
        int n, seed, type, age;
    } pp[] = {
        { 19, 1234, 0, 3},
        { 19, 1236, 0, 3},
        { 18, 1234, 1, 2},
        { 18, 1237, 1, 2},
        { 14, 1234, 2, 3},
        { 14, 1236, 2, 3},
        {  2, 1234, 0, 4},
        {  1, 1234, 1, 5},
    };

    float x = 50;
    float z = 50;
    int r1 = 75;
    int r2 = 620;

    for (int j = 0; j < sizeof (pp) / sizeof (plantplan); j++) {
        for (int i = 0; i < pp[j].n; i++) {
            float a = rand() % 360;
            float b = r1 + (rand() % r2);
            float pos[3] = {x+sin(a * 0.017454) * b, 0, z+cos(a * 0.017454) * b};
            float rot[3] = {0, 10 * (rand() % 36), 0};
            planet->spawnObject(new cTree(pos, rot, pp[j].seed, pp[j].type, pp[j].age));
        };
    }

}

//---------------------------------------------------------------------------

cObject* cPSO_M1::init(cWorld* world) {
    // Make Sure Randoms look the same for mission creation.
    srand(0);

    // Scene: World and Background
    world->mBackground = new cDomeBackground;

    cWorld::instance->sendMessage("* VICTORY:\n    Destroy the auxilary generator\n    buildings to disable the defense\n    system.\n");
    cWorld::instance->sendMessage("* DEFEAT:\n    The main building should not\n    be destoryed.\n");

    if (true) {
        world->mHour = 3;
        //world->mMinutes = 0;
        //world->mSeconds = 0;
    } else {
        float hour;
        getSystemHour(hour);
        world->mHour = (int) hour;
        world->mMinute = 0;
        world->mSecond = 0;
    }

    // Player Mech
    cObject* player = NULL;
    if (true) {
        float pos[3] = {0, 100.1, 300};
        cMech* mech = new cMech(pos);
        player = mech;
        assert(mech != NULL);
        mech->mPad = new cPad;
        mech->mName = "Alpha";
        mech->mController->mEnabled = false; // Disable Autopilot.
        mech->addRole(cObject::RED);
        mech->addRole(cObject::HUMANPLAYER);
        //mech->remRole(cObject::COLLIDEABLE); // untouchable
        mech->addEnemy(cObject::BLUE);
        world->spawnObject(mech);
        // Weapons
        if (true) {
            //mech->mountWeapon((char*)"LTorsor", new cExplosion);
            //mech->mountWeapon((char*) "Center", new cMachineGun);
            if (true) {
                //mech->mountWeapon((char*) "LUpArm",  new cMachineGun);
                //mech->mountWeapon((char*) "LTorsor", new cMachineGun);
                //mech->mountWeapon((char*) "RTorsor", new cMachineGun);
                //mech->mountWeapon((char*) "RUpArm",  new cMachineGun);
                mech->mountWeapon((char*) "Center", new cMachineGun);
            }
            if (true) {
                //mech->mountWeapon((char*) "LUpArm", new cPlasmaGun);
                //mech->mountWeapon((char*) "LLoArm", new cPlasmaGun);
                //mech->mountWeapon((char*) "RUpArm", new cPlasmaGun);
                //mech->mountWeapon((char*) "RLoArm", new cPlasmaGun);
                //mech->mountWeapon((char*) "Center", new cPlasmaGun);
                mech->mountWeapon((char*) "LTorsor", new cPlasmaGun);
                //mech->mountWeapon((char*) "RTorsor", new cPlasmaGun);
            }
            if (true) {
                //mech->mountWeapon((char*) "LTorsor", new cSparkGun);
                mech->mountWeapon((char*) "RTorsor", new cSparkGun);
            }
            if (true) {
                mech->mountWeapon((char*) "LUpArm", new cRaybeam);
                //mech->mountWeapon((char*) "RLoArm", new cRaybeam);
            }
            if (true) {
                //mech->mountWeapon((char*) "LTorsor", new cHomingMissile);
                mech->mountWeapon((char*) "RUpArm", new cHomingMissile);
            }
        }
    }

    // Buildings
    if (!false) {
        // The Space-Ship Port
        cBuilding* port = new cBuilding(-3 * 3, 1, 0, 9, 1, 3);
        world->spawnObject(port);
        mDefeat.push_back(port);
        port = new cBuilding(-4 * 3, 0, -1, 12, 1, 5);
        world->spawnObject(port);
        mDefeat.push_back(port);
        // Bay-Road
        for (int i = 0; i < 6; i++) {
            world->spawnObject(new cTile(i, 0, 0, cTile::KIND_ROAD_EASTWEST));
        }

        // Generators
        for (int i = 0; i < 5; i++) {
            float a = (360 / 5) * i * 0.017454;
            float r = 40;
            cBuilding* hub = new cBuilding(r * sin(a), 0, r * cos(a), 3, 1, 2);
            world->spawnObject(hub);
            mVictory.push_back(hub);
        }
    }

    // Turrets
    const int nt = 20;
    for (int i = 0; i < nt; i++) {
        float a = (360 / nt) * i * 0.017454;
        float r = 57;
        if (true) {
            float pos[3] = {r * sin(a), 0, r * cos(a)};
            float rot[3] = {0, 180 + a / 0.017454, 0};
            cMech* mech = new cMech(pos, rot);
            assert(mech != NULL);
            mech->mPad = new cPad;
            mech->mName = "Turret";
            mech->addRole(cObject::BLUE);
            mech->addRole(cObject::IMMOBILE);
            mech->addEnemy(cObject::RED);
            world->spawnObject(mech);

            if (rand() % 100 < 25)
                switch (rand() % 7) {
                    case 0: mech->mountWeapon((char*) "LTorsor", new cPlasmaGun);
                        break;
                    case 1: mech->mountWeapon((char*) "LTorsor", new cMachineGun);
                        break;
                    case 2: mech->mountWeapon((char*) "LTorsor", new cRaybeam);
                        break;
                    case 3: mech->mountWeapon((char*) "LTorsor", new cSparkGun);
                        break;
                    default: mech->mountWeapon((char*) "LTorsor", new cHomingMissile);
                }
            switch (rand() % 7) {
                case 0: mech->mountWeapon((char*) "RTorsor", new cPlasmaGun);
                    break;
                case 1: mech->mountWeapon((char*) "RTorsor", new cMachineGun);
                    break;
                case 2: mech->mountWeapon((char*) "RTorsor", new cRaybeam);
                    break;
                case 3: mech->mountWeapon((char*) "RTorsor", new cSparkGun);
                    break;
                default: mech->mountWeapon((char*) "RTorsor", new cHomingMissile);
            }
            //mech->mountWeapon((char*) "RTorsor", new cPlasmaGun);
            //mech->mountWeapon((char*) "RTorsor", new cMachineGun);
            //mech->mountWeapon((char*) "RTorsor", new cRaybeam);
            //mech->mountWeapon((char*) "RTorsor", new cSparkGun);
            //mech->mountWeapon((char*) "RTorsor", new cHomingMissile);
        }
    }
    /*
    for (int i = 0; i < 2; i++) {
        for (int j = 0; j < 6; j++) {
            if (true) {
                float pos[3] = {5 + j*10, 0, 20-20*i
                };
                float rot[3] = {0, 180*(1-i), 0
                };
                cMech* mech = new cMech(pos, rot);
                assert(mech != NULL);
                mech->mPad = new cPad;
                mech->mName = "Turret";
                mech->addRole(cObject::BLUE);
                mech->addRole(cObject::IMMOBILE);
                mech->addEnemy(cObject::RED);
                world->spawnObject(mech);
                mech->mountWeapon((char*) "LTorsor", new cPlasmaGun);
                mech->mountWeapon((char*) "RTorsor", new cPlasmaGun);
            }
        }
    }
     */

    mDefeat.push_back(player);
    return player;
}

void cPSO_M1::onVictory() {
    cMission::onVictory();
}

void cPSO_M1::onDefeat() {
    cMission::onDefeat();
}


#ifdef XMLMISSION
#include <iostream>
using namespace std;
#include <expat.h>

struct Data {
    int depth;
};

void startElement(void *data, const char *el, const char **attr) {
    Data* d = (Data*) data;
    for (int i = 0; i < d->depth; i++) cout << "\t";
    cout << el << endl;
    d->depth++;
}

void endElement(void *data, const char *el) {
    Data* d = (Data*) data;
    d->depth--;
}

void charHandler(void *data, const XML_Char *s, int len) {

}

#endif

cObject* cXMLMission::init(cWorld* world) {
#ifdef XMLMISSION
    Data data;
    data.depth = 0;

    char buf[1024];
    XML_Parser parser = XML_ParserCreate(NULL);
    XML_SetUserData(parser, &data);
    XML_SetElementHandler(parser, startElement, endElement);
    XML_SetCharacterDataHandler(parser, charHandler);
    int done = 0;
    FILE* in = stdin;
    do {
        size_t len = fread(buf, 1, sizeof (buf), in);
        done = len < sizeof (buf);
        if (!XML_Parse(parser, buf, sizeof (buf), done)) {
            done = -1;
            // error.
        }
    } while (!done);
    XML_ParserFree(parser);
    if (in != stdin) fclose(in);
#endif
    return NULL;
}

